<?php

class RobotDetector {
	private $robots = array(
		'abcdatos'              => true,
		'acme-spider'           => true,
		'ahoythehomepagefinder' => true,
		'Alkaline'              => true,
		'anthill'               => true,
		'appie'                 => true,
		'arachnophilia'         => true,
		'arale'                 => true,
		'araneo'                => true,
		'araybot'               => true,
		'architext'             => true,
		'aretha'                => true,
		'ariadne'               => true,
		'arks'                  => true,
		'aspider'               => true,
		'atn'                   => true,
		'atomz'                 => true,
		'auresys'               => true,
		'backrub'               => true,
		'bayspider'             => true,
		'bbot'                  => true,
		'bigbrother'            => true,
		'bingbot'               => true,
		'bjaaland'              => true,
		'blackwidow'            => true,
		'blindekuh'             => true,
		'Bloodhound'            => true,
		'borg-bot'              => true,
		'boxseabot'             => true,
		'brightnet'             => true,
		'bspider'               => true,
		'cactvschemistryspider' => true,
		'calif'                 => true,
		'curl'                  => true,
		'cassandra'             => true,
		'cgireader'             => true,
		'checkbot'              => true,
		'christcrawler'         => true,
		'churl'                 => true,
		'cienciaficcion'        => true,
		'cmc'                   => true,
		'Collective'            => true,
		'combine'               => true,
		'confuzzledbot'         => true,
		'coolbot'               => true,
		'core'                  => true,
		'cosmos'                => true,
		'cruiser'               => true,
		'cusco'                 => true,
		'cyberspyder'           => true,
		'cydralspider'          => true,
		'desertrealm'           => true,
		'deweb'                 => true,
		'dienstspider'          => true,
		'digger'                => true,
		'diibot'                => true,
		'directhit'             => true,
		'dnabot'                => true,
		'download_express'      => true,
		'dragonbot'             => true,
		'dwcp'                  => true,
		'e-collector'           => true,
		'ebiness'               => true,
		'eit'                   => true,
		'elfinbot'              => true,
		'emacs'                 => true,
		'emcspider'             => true,
		'esculapio'             => true,
		'esther'                => true,
		'evliyacelebi'          => true,
		'nzexplorer'            => true,
		'fastcrawler'           => true,
		'fdse'                  => true,
		'felix'                 => true,
		'ferret'                => true,
		'fetchrover'            => true,
		'fido'                  => true,
		'finnish'               => true,
		'fireball'              => true,
		'fish'                  => true,
		'fouineur'              => true,
		'francoroute'           => true,
		'freecrawl'             => true,
		'funnelweb'             => true,
		'gama'                  => true,
		'gazz'                  => true,
		'gcreep'                => true,
		'getbot'                => true,
		'geturl'                => true,
		'golem'                 => true,
		'googlebot'             => true,
		'grapnel'               => true,
		'griffon'               => true,
		'gromit'                => true,
		'gulliver'              => true,
		'gulperbot'             => true,
		'hambot'                => true,
		'harvest'               => true,
		'havindex'              => true,
		'hi'                    => true,
		'hometown'              => true,
		'wired-digital'         => true,
		'htdig'                 => true,
		'htmlgobble'            => true,
		'hyperdecontextualizer' => true,
		'iajabot'               => true,
		'ibm'                   => true,
		'iconoclast'            => true,
		'Ilse'                  => true,
		'imagelock'             => true,
		'incywincy'             => true,
		'informant'             => true,
		'infoseek'              => true,
		'infoseeksidewinder'    => true,
		'infospider'            => true,
		'inspectorwww'          => true,
		'intelliagent'          => true,
		'irobot'                => true,
		'iron33'                => true,
		'israelisearch'         => true,
		'javabee'               => true,
		'JBot'                  => true,
		'jcrawler'              => true,
		'askjeeves'             => true,
		'jobo'                  => true,
		'jobot'                 => true,
		'joebot'                => true,
		'jubii'                 => true,
		'jumpstation'           => true,
		'kapsi'                 => true,
		'katipo'                => true,
		'kdd'                   => true,
		'kilroy'                => true,
		'ko_yappo_robot'        => true,
		'larbin'                => true,
		'legs'                  => true,
		'linkidator'            => true,
		'linkscan'              => true,
		'linkwalker'            => true,
		'lockon'                => true,
		'lycos'                 => true,
		'macworm'               => true,
		'magpie'                => true,
		'marvin'                => true,
		'mattie'                => true,
		'mediafox'              => true,
		'merzscope'             => true,
		'meshexplorer'          => true,
		'MindCrawler'           => true,
		'mnogosearch'           => true,
		'moget'                 => true,
		'momspider'             => true,
		'monster'               => true,
		'motor'                 => true,
		'msnbot'                => true,
		'muncher'               => true,
		'muninn'                => true,
		'muscatferret'          => true,
		'mwdsearch'             => true,
		'myweb'                 => true,
		'NDSpider'              => true,
		'netcarta'              => true,
		'netmechanic'           => true,
		'netscoop'              => true,
		'newscan-online'        => true,
		'nhse'                  => true,
		'nomad'                 => true,
		'northstar'             => true,
		'objectssearch'         => true,
		'occam'                 => true,
		'octopus'               => true,
		'OntoSpider'            => true,
		'openfind'              => true,
		'orb_search'            => true,
		'packrat'               => true,
		'pageboy'               => true,
		'parasite'              => true,
		'patric'                => true,
		'pegasus'               => true,
		'perignator'            => true,
		'perlcrawler'           => true,
		'phantom'               => true,
		'phpdig'                => true,
		'piltdownman'           => true,
		'pimptrain'             => true,
		'pioneer'               => true,
		'pitkow'                => true,
		'pjspider'              => true,
		'pka'                   => true,
		'plumtreewebaccessor'   => true,
		'poppi'                 => true,
		'portalb'               => true,
		'psbot'                 => true,
		'Puu'                   => true,
		'python'                => true,
		'raven'                 => true,
		'rbse'                  => true,
		'resumerobot'           => true,
		'rhcs'                  => true,
		'rixbot'                => true,
		'roadrunner'            => true,
		'robbie'                => true,
		'robi'                  => true,
		'robocrawl'             => true,
		'robofox'               => true,
		'robozilla'             => true,
		'roverbot'              => true,
		'rules'                 => true,
		'safetynetrobot'        => true,
		'scooter'               => true,
		'search_au'             => true,
		'search-info'           => true,
		'searchprocess'         => true,
		'senrigan'              => true,
		'sgscout'               => true,
		'shaggy'                => true,
		'shaihulud'             => true,
		'sift'                  => true,
		'simbot'                => true,
		'site-valet'            => true,
		'sitetech'              => true,
		'skymob'                => true,
		'slcrawler'             => true,
		'slurp'                 => true,
		'smartspider'           => true,
		'snooper'               => true,
		'solbot'                => true,
		'speedy'                => true,
		'spider_monkey'         => true,
		'spiderbot'             => true,
		'spiderline'            => true,
		'spiderman'             => true,
		'spiderview'            => true,
		'spry'                  => true,
		'ssearcher'             => true,
		'suke'                  => true,
		'suntek'                => true,
		'sven'                  => true,
		'sygol'                 => true,
		'tach_bw'               => true,
		'tarantula'             => true,
		'tarspider'             => true,
		'tcl'                   => true,
		'techbot'               => true,
		'templeton'             => true,
		'titin'                 => true,
		'titan'                 => true,
		'tkwww'                 => true,
		'tlspider'              => true,
		'ucsd'                  => true,
		'udmsearch'             => true,
		'uptimebot'             => true,
		'urlck'                 => true,
		'us'                    => true,
		'valkyrie'              => true,
		'verticrawl'            => true,
		'victoria'              => true,
		'visionsearch'          => true,
		'voidbot'               => true,
		'voyager'               => true,
		'vwbot'                 => true,
		'w3index'               => true,
		'w3m2'                  => true,
		'wallpaper'             => true,
		'wanderer'              => true,
		'wapspider'             => true,
		'webbandit'             => true,
		'webcatcher'            => true,
		'webcopy'               => true,
		'webfetcher'            => true,
		'webfoot'               => true,
		'webinator'             => true,
		'weblayers'             => true,
		'weblinker'             => true,
		'webmirror'             => true,
		'webmoose'              => true,
		'webquest'              => true,
		'webreader'             => true,
		'webreaper'             => true,
		'webs'                  => true,
		'websnarf'              => true,
		'webspider'             => true,
		'webvac'                => true,
		'webwalk'               => true,
		'webwalker'             => true,
		'webwatch'              => true,
		'wget'                  => true,
		'whatuseek'             => true,
		'whowhere'              => true,
		'wlm'                   => true,
		'wmir'                  => true,
		'wolp'                  => true,
		'wombat'                => true,
		'worm'                  => true,
		'wwwc'                  => true,
		'wz101'                 => true,
		'xget'                  => true,
		'Nederland.zoek'        => true,
		'nutch'                 => true
	);

	public function is_robot() {
		$user_agent = $_SERVER['HTTP_USER_AGENT'];

		$common_browsers = 'Chrome|Firefox|MSIE|Safari|Opera';
		if ( preg_match( '/' . $common_browsers . '/i', $user_agent ) ) {
			return false;
		}

		$agent_name = preg_replace( '#^(.+?)/.*$#', '$1', $user_agent );

		return ! empty( $this->robots[ $agent_name ] );
	}
}
