<?php
/*
GUTENBERG BLOCK INTEGRATION
*/


function fca_eoi_gutenblock() {
	
	wp_register_script(
		'fca_eoi_gutenblock_script',
		FCA_EOI_PLUGIN_URL . '/assets/admin/block.js',
		array( 'wp-blocks', 'wp-element', 'wp-editor' ),
		FCA_EOI_VER
	);
	wp_register_style( 'fca-eoi-common-css', FCA_EOI_PLUGIN_URL . '/assets/style-new.min.css', array(), FCA_EOI_VER );

			
	if ( function_exists( 'register_block_type' ) ) {
		register_block_type( 'optin-cat/gutenblock',
			array(
				'editor_script' => 'fca_eoi_gutenblock_script',
				'editor_style' => 'fca-eoi-common-css',
				'render_callback' => 'fca_eoi_gutenblock_render',
				'attributes' => array( 
					'post_id' => array( 
						'type' => 'string',
						'default' => '0'				
					)
				)
			)
		);
	}
	
}
add_action( 'init', 'fca_eoi_gutenblock' );


function fca_eoi_gutenblock_enqueue() {
	
	$posts = get_posts( array(
		'post_type' => 'easy-opt-ins',
		'post_status' => 'publish',
		'posts_per_page' => -1,
		'fields' => 'ids'
	));
	
	$table_list = array( 
		array(
			'value' => 0,
			'label' => 'Select an optin form',
		) 
	);
	
	forEach ( $posts as $p ) {
		$fca_eoi = get_post_meta( $p, 'fca_eoi', true );
		$layout_string = empty( $fca_eoi[ 'layout' ] ) ? '' : $fca_eoi[ 'layout' ];
		$title = get_the_title( $p );
		if ( empty( $title ) ) {
			$title = __("(no title)", 'easy-opt-ins' );
		}
		if ( strpos( $layout_string, 'postbox' )  !== false ) {
			$table_list[] = array(
				'value' => $p,
				'label' => html_entity_decode( $title ),
			);
		}
	}
	
	wp_localize_script( 'fca_eoi_gutenblock_script', 'fca_eoi_gutenblock_script_data', array( 'optins' => $table_list, 'editurl' => admin_url( 'post.php' ), 'newurl' => admin_url( 'post-new.php' )  ) );
	
}
add_action( 'enqueue_block_editor_assets', 'fca_eoi_gutenblock_enqueue' );


function fca_eoi_gutenblock_render( $attributes ) {

	$id = empty( $attributes['post_id'] ) ? 0 : $attributes['post_id'];
	if ( $id ) {		
		return do_shortcode( "[easy-opt-in id='$id']" );
	}
	return '<p>' . __( 'Click here and select an optin form from the menu above.', 'easy-opt-ins' ) . '</p>';
}